Attribute VB_Name = "search"
'CopyRight(c) 1998-2006 Korniloff E.

Option Explicit

Public Const nopiece = 0
Public Const cross = 1
Public Const nil = 2

Public Const NullMove = -1


Public Type TNode
  move As Integer
  score As Long
End Type

Public Const MaxPly = 100
Public Const INF = 1000000

Public Type TGame
  pos(3 * 3) As Integer
  tree(MaxPly * 9) As TNode
  treeCnt(MaxPly) As Integer
  ply As Integer
  side As Integer
  xside As Integer
  cntPieces As Integer
End Type

Public Game As TGame
Public score_table(9) As Long







Public Sub NewGame()
  Dim i As Integer
  
  For i = 0 To 8
    Game.pos(i) = nopiece
    1.1(i).Picture = 1.im_empty.Picture
  Next i
  Game.side = cross
  Game.xside = nil
  Game.cntPieces = 0
End Sub



Public Sub Generate()
 Dim i As Integer
 Dim n As Integer
  
 With Game
  n = .treeCnt(.ply)
  For i = 0 To 8
    If .pos(i) = nopiece Then
     With .tree(n)
       .move = i
       .score = score_table(i)
       n = n + 1
     End With
    End If
  Next i
  .treeCnt(.ply + 1) = n
 End With
End Sub

Public Function IsFullLine(p As Integer) As Boolean
 Dim x As Integer
 Dim y As Integer
 Dim i As Integer
 
 For y = 0 To 2
   For x = 0 To 2
     If Game.pos(y * 3 + x) <> p Then GoTo nextLine1
   Next x
   IsFullLine = True
   Exit Function
nextLine1:
 Next y
 
 
 For x = 0 To 2
   For y = 0 To 2
     If Game.pos(y * 3 + x) <> p Then GoTo nextLine2
   Next y
   IsFullLine = True
   Exit Function
nextLine2:
 Next x
  
  
 For i = 0 To 8 Step 4
  If Game.pos(i) <> p Then GoTo nextLine3
 Next i
 IsFullLine = True
 Exit Function

nextLine3:


 For i = 2 To 6 Step 2
  If Game.pos(i) <> p Then GoTo nextLine4
 Next i
 IsFullLine = True
 Exit Function

nextLine4:

  
 IsFullLine = False
End Function



Public Sub MakeMove(node As TNode)
   Dim tmp As Integer
   With Game
     If node.move <> NullMove Then
      .pos(node.move) = .side
      .cntPieces = .cntPieces + 1
     End If
     .ply = .ply + 1
     tmp = .side
     .side = .xside
     .xside = tmp
   End With
End Sub

Public Sub UnMakeMove(node As TNode)
 Dim tmp As Integer
   With Game
     If node.move <> NullMove Then
      .pos(node.move) = nopiece
      .cntPieces = .cntPieces - 1
     End If
     .ply = .ply - 1
     tmp = .side
     .side = .xside
     .xside = tmp
   End With
End Sub

Public Sub InsertMoveInGame(node As TNode)
  MakeMove node
  Game.ply = 0
End Sub

Public Function Search(ByVal depth As Integer, ByVal alpha As Long, _
         ByVal beta As Long) As Long
 
  Dim j As Integer
  Dim tmp As Long
  Dim nextBeta As Long
  Dim ZerroMove As TNode
  ZerroMove.move = NullMove
  
  
  With Game
   
    
      If .ply > 0 Then Generate
      For j = .treeCnt(.ply) To .treeCnt(.ply + 1) - 1
        Pick j, (.treeCnt(.ply + 1) - 1)
        MakeMove .tree(j)
       
        
        If IsFullLine(.xside) Then
           tmp = INF - .ply
        ElseIf .cntPieces = 9 Then
           tmp = 0
        ElseIf depth - 1 <= 0 Then
           tmp = -Evaluate
        Else
          nextBeta = beta
          
    
        '  MakeMove ZerroMove
        '  .treeCnt(.ply) = .treeCnt(.ply - 1)
        '  tmp = Search(depth - 20, alpha, beta)
        '  UnMakeMove ZerroMove
        
          tmp = -Evaluate
            
          If tmp < nextBeta Then nextBeta = tmp
    
          If nextBeta <= alpha Then
             tmp = alpha
          Else
            tmp = -Search(depth - 1, -nextBeta, -alpha)
          End If
        End If
        UnMakeMove .tree(j)
        If TimeUp Then Exit For
        If tmp > alpha Then
          alpha = tmp
          If score_table(.tree(j).move) < INF - 100 Then
             score_table(.tree(j).move) = score_table(.tree(j).move) + 1
          End If
          .tree(j).score = depth * 1000 + j
          If alpha >= beta Then Exit For
        End If
      Next j
      Search = alpha
  End With
End Function

Public Function OpSide(c As Integer) As Integer
  If c = cross Then
    OpSide = nil
  Else
    OpSide = cross
  End If
End Function

Public Sub Pick(low As Integer, high As Integer)
  Dim j As Integer
  Dim max As Long
  Dim i As Integer
  Dim tmp As TNode
  
  With Game
  
    i = low
    max = .tree(low).score
    For j = low + 1 To high
      If .tree(j).score > max Then
        max = .tree(j).score
        i = j
      End If
    Next j
    
    If i <> low Then
      tmp = .tree(low)
      .tree(low) = .tree(i)
      .tree(i) = tmp
    End If
  End With
End Sub

Public Function EndGame() As Boolean
  With Game
    If IsFullLine(cross) Or IsFullLine(nil) Or (.cntPieces = 9) Then
      EndGame = True
    Else
      EndGame = False
    End If
  End With
End Function



Public Function MoveMachin(ByRef retMove As TNode) As Boolean
  Dim depth As Integer
  Dim j As Integer
  Dim init_score

  
  init_score = Array(3, 2, 3, _
                     2, 4, 2, _
                     3, 2, 3)
  
  
  
  With Game
  If EndGame Then
      MoveMachin = False
  
  Else
  
    For j = 0 To 8
      score_table(j) = Rnd * (init_score(j) * 4) + 1
     
    Next j
  
    Generate
    TimeReset (2)
  
    For depth = 2 To 9
       Search depth, -INF, INF
       If TimeUp Then Exit For
    Next depth
  
 
    
    Pick (.treeCnt(0)), (.treeCnt(1) - 1)
    retMove = .tree(0)
    MoveMachin = True
   End If
  End With
End Function

Public Function Evaluate()
  Dim s0 As Long
  Dim s1 As Long
  Dim j As Integer
  
  s0 = 0
  s1 = 0
  With Game
    For j = 0 To 8
      If .pos(j) = .side Then
        s0 = s0 + score_table(j)
      ElseIf .pos(j) = .xside Then
        s1 = s1 + score_table(j)
      End If
    Next j
  End With
  Evaluate = s0 - s1
End Function
